//Basarely_illusion.cpp
//Written by Yutaka NAKAJIMA on 06/04/20.

#include <psychlops.h>
using namespace Psychlops;

void VasarelyIllusion() {
	double Max_size=500;
	const int nRectMax = 100;
	int nRect=5;
	int rect_lum  =0;
	double bg_lum    = 0.2;
	double lum[nRectMax];
	
	Psychlops::Rectangle rect[nRectMax], rect2;
		
	Range rng;
	Independent << nRect | "Number of Rect "      |   5<= rng <=nRectMax | 10 | 5 ;
	Independent << Max_size | "Rect Size"      |   50<= rng <=500 | 100 | 10 ;
	Independent << rect_lum  | "Rect Luminance" | 0<=rng<=1 |  1  | 1;
	Independent << bg_lum    | "BG Luminance"   | 0.0<=rng<=1.0 |  0.1 | 0.05;

	while(!Input::get(Keyboard::esc)) {
		Display::clear(Color(bg_lum));

		for (int i=0; i<nRect;i++){
			rect[i].set(Max_size*(i+1)/nRect,Max_size*(i+1)/nRect );
			lum[i]=i*(1.0/nRect);
			rect[i].centering();
		}
		
		for (int i=0; i<nRect;i++){
				switch(rect_lum){
					case 0: rect[(nRect-1)-i].display(lum[i]); break;				
					case 1: rect[(nRect-1)-i].display(lum[(nRect-1)-i]); break;				
				};
			}	
		
		Display::flip();
	}	
}

void psychlops_main() {

	Canvas display(Canvas::fullscreen);

	Procedure p;
	p.setDesign(Procedure::DEMO);
	p.setProcedure(VasarelyIllusion);
	p.run();

}